#include <iostream>
  #include <gtk/gtk.h>

  static void destroy_window( GtkWidget *widget,
                      gpointer  pointer )
 {
     gtk_main_quit ();
 }
 
 void move_button();
 
    GtkWidget *window;
    GtkWidget *fixed;
 	GtkWidget *label;
 	GtkWidget *button;
 	GtkWidget *view;
    GtkTextBuffer *buffer;
    GtkWidget *scrolled_window;
    GtkWidget *entry;
 	GtkTextIter startiter;
 	GtkTextIter stopiter;
    gint offset; 
    
 int main(int argc, char *argv[])
 {
 	  
 	gtk_init (&argc, &argv);
 	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 	 gtk_window_set_title(GTK_WINDOW(window), "Fixed Container");
 	gtk_window_set_default_size (GTK_WINDOW (window), 300, 350);
 	g_signal_connect (G_OBJECT (window), "destroy",G_CALLBACK (destroy_window), NULL);
 	
 	
 	fixed=gtk_fixed_new();
 	gtk_container_add (GTK_CONTAINER (window), fixed);
 	gtk_widget_show(fixed);
 	
 		
	button = gtk_button_new_with_label ("Press me");
      gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (move_button), fixed);
      gtk_fixed_put (GTK_FIXED (fixed), button, 20, 300);
      
	  
  view = gtk_text_view_new ();
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
  gtk_text_buffer_set_text (buffer, "\nHello, this is some text", -1);
  
    
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_set_border_width (GTK_CONTAINER (scrolled_window), 10);
  
  gtk_widget_set_usize(scrolled_window, 280, 290);
  
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
      gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_window), view);
      gtk_fixed_put (GTK_FIXED (fixed), scrolled_window, 10, 10);
      
    entry= gtk_entry_new();
    gtk_entry_set_max_length(GTK_ENTRY(entry), 30);
    gtk_entry_set_text(GTK_ENTRY(entry),"Hello, this is some text");
    gtk_fixed_put (GTK_FIXED (fixed), entry, 100, 300); 
    
 	gtk_widget_show_all (window);
 	gtk_main ();
 	return 0;
 }
 
 void move_button(){
	  gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &startiter, gtk_entry_get_text(GTK_ENTRY(entry)), -1);
      gtk_text_buffer_get_iter_at_offset (buffer, &startiter, 0);
      gtk_text_buffer_get_iter_at_offset (buffer, &stopiter, -1);
      gtk_text_buffer_insert  (buffer, &startiter, "\n", -1);
 }
