#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <ctime> 
#include <cstdlib>
#include <math.h>
#include <string>

#include "omp.h"
using namespace std;

int main(){
	string s;
	long double d,res;
	unsigned long x,y,r,i,upper,lowest,range,points,points_in;
	long n=omp_get_num_procs();
	int nthreads, tid;
	time_t t1; 
	
	lowest=0;
	
	cout<<"Calculation of pi with Monte Carlo method:\n";
         
cout<<"\nDefine number of processors to be used:";
cin>>n;
if (n>=omp_get_num_procs()){
	n=omp_get_num_procs();
}
        
    cout<<"Give radious (default value is 1000): ";
    cin>>r;
    if(r<=10){
    	r=100;
	}
    range=(r-lowest)+1; 
	points_in=0;
	
	cout<<"Give number of points: ";
    cin>>points;
    if(points<=1){
    	points=100;
	}
		



omp_set_num_threads(n);

#pragma omp parallel shared(points, range,r,lowest) private(nthreads, tid,i,x,y,d,upper,t1) reduction (+:points_in)
{	
/* Obtain thread number */
	 tid = omp_get_thread_num();
    /*Obtain total number of threads*/  
     nthreads = omp_get_num_threads();
 
(void) time(&t1);
srand48((long) t1 + tid);
srand((long)t1+tid+nthreads*2);	
      
  if (tid == 0) 
    {
    nthreads = omp_get_num_threads();
    printf("Number of threads = %d\n", nthreads);
    }
  printf("Hello World from thread = %d\n", tid);
upper=0;
i=1;
#pragma omp for   
for(i=1; i<=points;i++){ 
    	
        x= lowest;
        x=x+lrand48();
        x=x*x;
        x=x+range;
        x=x%r;
        x=x + 1; 
        
        y= lowest;
        y=y+rand();
        y=y*y;
        y=y*range;
        y=y%r;
        y=y + 1; 
        
        d=sqrt((x*x)+(y*y));
        if(d<=r){
        	
        	points_in+=1;
        	
		}
		upper++;
        //cout << x/y << endl; 
    }
  printf("thread = %d   interations=%lu   points_in=%lu\n", tid,upper,points_in);   

}	

	res=4*((long double)(points_in)/(long double)(points));
		
std::cout.precision( 22 ) ;
//std::cout.setf( std::ios::fmtflags(), std::ios::floatfield ) ;
cout<<"\n\npoints_in= "<<points_in<<"   pi= "<< res;
   return 0;
}

